searchNodes=[{"doc":"Absinthe integration for Charon.","ref":"CharonAbsinthe.html","title":"CharonAbsinthe","type":"module"},{"doc":"Absinthe helper to send any response cookies present in the context. To be used as a before_send hook for Absinthe.Plug . Response cookies will be set by CharonAbsinthe.PostSessionChangeMiddleware .","ref":"CharonAbsinthe.html#send_context_cookies/2","title":"CharonAbsinthe.send_context_cookies/2","type":"function"},{"doc":"Config module for CharonAbsinthe . Charon.Config . from_enum ( ... , optional_modules : %{ CharonAbsinthe =&gt; %{ access_token_pipeline : MyApp.AccessTokenPipeline , refresh_token_pipeline : MyApp.RefreshTokenPipeline , auth_error_handler : &amp; MyApp.Absinthe . auth_error_handler / 2 } } ) The following options are supported: :access_token_pipeline (required). A Plug that validates an access token (see readme). :refresh_token_pipeline (required). A Plug that validates a refresh token (see readme). :auth_error_handler (required). A function that takes an %Absinthe.Resolution{} struct and an error message, and returns the resolution struct.","ref":"CharonAbsinthe.Config.html","title":"CharonAbsinthe.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"CharonAbsinthe.Config.html#from_enum/1","title":"CharonAbsinthe.Config.from_enum/1","type":"function"},{"doc":"","ref":"CharonAbsinthe.Config.html#t:t/0","title":"CharonAbsinthe.Config.t/0","type":"type"},{"doc":"Plug to bridge the gap between Plug's conn and Abinthe's context. Processes the auth token as an access token, and stores the conn in the context as :charon_conn so that it may be used in Absinthe resolvers for manipulation sessions with Charon.SessionPlugs . Note that no guarantees are offered about the consistency of the assigns/private fields etc of this conn struct apart from the Charon-related contents.","ref":"CharonAbsinthe.HydrateContextPlug.html","title":"CharonAbsinthe.HydrateContextPlug","type":"module"},{"doc":"Absinthe middleware to update the resolution after a session is created, refreshed or dropped. Transfers resolution.value.resp_cookies to resolution.","ref":"CharonAbsinthe.PostSessionChangeMiddleware.html","title":"CharonAbsinthe.PostSessionChangeMiddleware","type":"module"},{"doc":"Absinthe middleware to require a valid access token. Can be used if the context was hydrated by CharonAbsinthe.HydrateContextPlug .","ref":"CharonAbsinthe.ReqAuthMiddleware.html","title":"CharonAbsinthe.ReqAuthMiddleware","type":"module"},{"doc":"Absinthe middleware to require a valid refresh token. Can be used if the context was hydrated by CharonAbsinthe.HydrateContextPlug .","ref":"CharonAbsinthe.ReqRefreshAuthMiddleware.html","title":"CharonAbsinthe.ReqRefreshAuthMiddleware","type":"module"},{"doc":"CharonAbsinthe is an extension package for Charon to use it with Absinthe .","ref":"readme.html","title":"CharonAbsinthe","type":"extras"},{"doc":"CharonAbsinthe Table of contents Documentation How to use Installation Setup the parent package Create an error handler Configuration Configure router Protect your schema Create a session resolver","ref":"readme.html#table-of-contents","title":"CharonAbsinthe - Table of contents","type":"extras"},{"doc":"Documentation (including this readme with module links resolved) can be found at https://hexdocs.pm/charon_absinthe .","ref":"readme.html#documentation","title":"CharonAbsinthe - Documentation","type":"extras"},{"doc":"Installation The package can be installed by adding charon_absinthe to your list of dependencies in mix.exs : def deps do [ { :charon_absinthe , &quot;~&gt; 0.2.0&quot; } ] end Setup the parent package Follow the Charon readme until you've created token pipelines. Create an error handler defmodule MyAppWeb.Absinthe do def authentication_error ( resolution , auth_error_msg ) do message = &quot;request could not be authenticated: \\# {auth_error_msg}&quot; extensions = %{ error : &quot;authentication_failure&quot; , reason : auth_error_msg } error = %{ message : message , extensions : extensions } Absinthe.Resolution . put_result ( resolution , { :error , error } ) end end Configuration Additional config is required, see CharonAbsinthe.Config . Configure router Add a pipeline with the CharonAbsinthe.HydrateContextPlug , route the graphql endpoint through it, and register the CharonAbsinthe.send_context_cookies/2 callback as an Absinthe.Plug :before_send hook. defmodule MyAppWeb.Router do use MyAppWeb , :router @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) pipeline :api do plug :accepts , [ &quot;json&quot; ] end pipeline :charon_auth do plug CharonAbsinthe.HydrateContextPlug , @config end scope &quot;/api&quot; do pipe_through :charon_auth forward &quot;/graphql&quot; , Absinthe.Plug , schema : MyAppWeb.Absinthe.Schema , before_send : { CharonAbsinthe , :send_context_cookies } end end Protect your schema Normal &quot;auth-required&quot; fields must be protected with CharonAbsinthe.ReqAuthMiddleware . The refresh mutation must be protected with CharonAbsinthe.ReqRefreshAuthMiddleware . Mutations that alter the session (login, logout, refresh, logout-all, logout-other...) must be followed by CharonAbsinthe.PostSessionChangeMiddleware . defmodule MyAppWeb.Absinthe.SessionTypes do use Absinthe.Schema.Notation alias MyAppWeb.Absinthe.SessionResolver alias CharonAbsinthe . { ReqAuthMiddleware , ReqRefreshAuthMiddleware , PostSessionChangeMiddleware } @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) object :session_mutations do field :login , type : :login_payload do arg :email , non_null ( :string ) arg :password , non_null ( :string ) arg :token_signature_transport , non_null ( :string ) resolve &amp; SessionResolver . login / 3 middleware PostSessionChangeMiddleware end field :logout , type : :logout_payload do middleware ReqAuthMiddleware , @config resolve &amp; SessionResolver . logout / 3 middleware PostSessionChangeMiddleware end field :refresh , type : :refresh_payload do middleware ReqRefreshAuthMiddleware , @config resolve &amp; SessionResolver . refresh / 3 middleware PostSessionChangeMiddleware end end end Create a session resolver Error handling is omitted. defmodule MyAppWeb.Absinthe.SessionResolver do alias Charon . { Utils , SessionPlugs } alias MyApp . { User , Users } @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) def login ( _parent , _args = %{ token_signature_transport : transport , email : email , password : password } , _resolution = %{ context : %{ charon_conn : conn } } ) do with { :ok , user } &lt;- Users . get_by ( email : email ) |&gt; Users . verify_password ( password ) do conn |&gt; Utils . set_token_signature_transport ( transport ) |&gt; Utils . set_user_id ( user . id ) |&gt; SessionPlugs . upsert_session ( @config ) |&gt; token_response ( ) end end def logout ( _parent , _args , _resolution = %{ context : %{ charon_conn : conn } } ) do conn |&gt; SessionPlugs . delete_session ( @config ) |&gt; then ( fn conn -&gt; { :ok , %{ resp_cookies : conn . resp_cookies } } end ) end def refresh ( _parent , _args , _resolution = %{ context : %{ charon_conn : conn , user_id : user_id } } ) do with % User { status : &quot;active&quot; } &lt;- Users . get_by ( id : user_id ) do conn |&gt; SessionPlugs . upsert_session ( @config ) |&gt; token_response ( ) end end ########### # Private # ########### defp token_response ( conn ) do tokens = conn |&gt; Utils . get_tokens ( ) |&gt; Map . from_struct ( ) session = conn |&gt; Utils . get_session ( ) |&gt; Map . from_struct ( ) { :ok , %{ resp_cookies : conn . resp_cookies , tokens : tokens , session : session } } end end","ref":"readme.html#how-to-use","title":"CharonAbsinthe - How to use","type":"extras"}]